package app24.filecounter;

import java.io.File;
import java.util.concurrent.Callable;

public class FileCountTask implements Callable {
    File dir;
    long fileCount = 0L;
    public FileCountTask(File dir) {
        this.dir = dir;
    }

    private void doCount(File parent) {
        if (!parent.exists()) {
            return;
        }
        File[] children = parent.listFiles();
        if (children == null) {
            return;
        }
        for (File child : children) {
            if (child.isDirectory()) {
                doCount(child);
            } else if (child.isFile()) {
                fileCount++;
            }
        }
    }

    @Override
    public Long call() throws Exception {
        System.out.println("Start counting " + dir);
        doCount(dir);
        System.out.println("Finished counting " + dir);
        return fileCount;
    }
}